import es,dnd,popuplib,spe,gamethread,cmdlib,random
from dnd import dnd
from spe import HookAction
from spe import HookType

def load():
    spe.parseINI('dnd/subscripts/signatures/mysigs.ini')
    spe.parseTypesINI('dnd/subscripts/signatures/mytypes.ini')
    spe.detourFunction('Respawn', HookType.Pre, pre_spawn)
    cmdlib.registerClientCommand('!escape', escape, 'Kobold Ability - Flee from battle')

    Human_Info = popuplib.create('Kobold Info')
    Human_Info.addline('Kobold Race Information:')
    Human_Info.addline(' 10% Decreased Damage')
    Human_Info.addline(' -10 Health')
    Human_Info.addline(' !escape - Flee from battle (cool down)')
    Human_Info.addline(' Health Regeneration')
    Human_Info.addline('-> 9. Main Menu')
    Human_Info.submenu(9, 'main_menu')
    
def unload():
    popuplib.delete('Kobold Info')
    cmdlib.unregisterClientCommand('!escape')
    spe.undetourFunction('Respawn', HookType.Pre, pre_spawn)
    
def escape(userid, args):
    if dnd.Player(userid).alive() and dnd.Player(userid).getRace() == 'Kobold':
        if es.ServerVar('allow_escape') == '1':
            if not dnd.Temp(userid).get('escape cool down'):
                dnd.Temp(userid).add('escape cool down', 1)
                gamethread.delayedname(3, 'dndtick', dnd.Temp(userid).add, ('escape cool down', -1))
                es.setplayerprop(userid, "CCSPlayer.baseclass.localdata.m_vecBaseVelocity", "%s,%s,300"%(random.choice([300,-300]), random.choice([300,-300])))
            else:
                dnd.dndTell(userid, 'You must wait to use that ability')
        else:
            dnd.dndTell(userid, 'You must wait 8 seconds from round start to use that ability')
            
def round_start(ev):
    es.set('allow_escape',0)
    gamethread.delayedname(8, 'dndtick', allowescape)
    
def allowescape():
    es.set('allow_escape',1)
    
def pre_spawn(args):
    userid = es.getuserid(es.gethandlefromindex(spe.getEntityIndex(args[0])))
    if dnd.Player(userid).getRace() == 'Kobold':
        dnd.Temp(userid).add('health', -10)
        dnd.Temp(userid).set('escape cool down', 0)
        dnd.regen(userid, 3, 1)
    return (HookAction.Continue, 0)
        

        